from World import score, character, string
import constants
import math

class TestScore(object):
    
    def test_new_score_num_should_be_zero(self):
        assert score.Score().num() >= 0
        
    def test_should_add_score_when_hero_attaches_to_a_string(self):
        s = score.Score()
        before_value = s.num()
        s.update(string.String())
        assert s.num() == (before_value + constants.ATTACH_BONUS)
        
    def test_should_not_add_score_when_not_on_string(self):
        s = score.Score()
        before_value = s.num()
        s.update(None)
        assert s.num() == before_value
        
    def test_should_add_score_when_higher_then_last_time(self):
        s = score.Score()
        rope = string.String()
        s.update(rope, 0)

        prev_value = s.num()
        s.update(rope, 100)
        assert s.num() > prev_value

        prev_value = s.num()
        s.update(rope, 1000)
        assert s.num() > prev_value

    def test_should_not_add_score_when_not_higher_than_last_time(self):
        s = score.Score()
        rope = string.String()
        height = 100
        
        s.update(rope, height)
        value1 = s.num()

        s.update(rope, height)
        value2 = s.num()

        assert value1 == value2
    
