from World import world, string, character
import constants

class TestWorld(object):
    def test_should_remove_dead_object(self):
        game_world = world.World()
        piece_of_string = string.String(0, 0, 1)
        game_world.add_object(piece_of_string)

        piece_of_string.die()
        game_world.cleanup()
        assert not game_world.contains(piece_of_string)

    def test_should_return_all_strings_in_world(self):
        game_world = world.World()
        assert len(game_world.all_strings()) == 0
        game_world.add_object(string.String())
        assert len(game_world.all_strings()) == 1
        game_world.add_object(character.Character())
        assert len(game_world.all_strings()) == 1
        game_world.add_object(string.String())
        assert len(game_world.all_strings()) == 2        

    def test_should_kill_objects_when_they_drop_off_the_edge_of_the_world(self):
        screen_height = 100
        robust_string = string.String(x=20, y=0)
        dead_string = string.String(x=20, y=screen_height + constants.BELOW_SCREEN_GRACE + 1)

        game_world = world.World()
        game_world.add_object(robust_string)
        game_world.add_object(dead_string)
        game_world.cleanup(screen_height)

        assert game_world.contains(robust_string)
        assert game_world.contains(dead_string) == False
